# -*- coding: utf_8 -*-
from __future__ import with_statement
print "b485"
os.chdir("/home/simuw/simuw08/nb/sage_notebook/worksheets/wstein/8/cells/26")
sage.server.notebook.interact.SAGE_CELL_ID=26
__SAGE_t__=cputime()
__SAGE_w__=walltime()
def exp_strategy_quiet(price_series, start, stop, alpha):
    investment = Integer(1)
    average_series = price_series.exponential_moving_average(alpha)
    for k in range(start, stop-Integer(1)):
         # day k -- moving average up to and including today.
         average = average_series[k]
         if price_series[k] >= average:
             signal = -Integer(1)
         else:
             signal = +Integer(1)
         percent_change = price_series[k+Integer(1)]/price_series[k] - Integer(1)
         if signal == Integer(1):  # buy
             investment = investment * (percent_change + Integer(1))
         else: # short
             investment = investment * (Integer(1)/(percent_change + Integer(1)))
    return investment

@interact
def f(start_days_ago=Integer(50), days=Integer(50),
       symbol=selector(symbols,buttons=True,default='dji')):
    start = start_days_ago; end = max(Integer(0), start_days_ago - days)
    if symbol == 'RANDOM':
        price_series = (TimeSeries([Integer(1)]) +
             TimeSeries(Integer(2)*start_days_ago+Integer(100)).randomize('normal',Integer(0),RealNumber('0.02'))).sums().exp()
    else:
        price_series = stocks[symbol]
    n = len(price_series)
    def g(alpha):
        return exp_strategy_quiet(price_series, n-start, n-end, alpha)
    show(line([(alpha, g(alpha)) for alpha in (ellipsis_range(RealNumber('0.05'),RealNumber('0.055'),Ellipsis,RealNumber('0.95')))]), xmin=Integer(0),ymin=Integer(0))
print "CPU time: %.2f s,  Wall time: %.2f s"%(cputime(__SAGE_t__), walltime(__SAGE_w__))

print "e485"
