# -*- coding: utf_8 -*-
from __future__ import with_statement
print "b94"
os.chdir("/home/simuw/simuw08/nb/sage_notebook/worksheets/wstein/8/cells/22")
sage.server.notebook.interact.SAGE_CELL_ID=22
def strategy(price_series, start, stop, n, verbose=False, contrarian=True):
    average_series = price_series.simple_moving_average(n)
    buyhold  = []
    strategy = []
    investment = Integer(1)
    if verbose:
       print '%-6s%-10s%-4s%-8s%-10s%8s'%('day','price',
            'sig','strategy ', 'buy&hold', '% change')
    start_price = price_series[start]
    for k in range(start, stop-Integer(1)):
         average = average_series[k]
         if price_series[k] >= average:
             signal = +Integer(1)
         else:
             signal = -Integer(1)
         if not contrarian: signal = -signal
         percent_change = price_series[k+Integer(1)]/price_series[k] - Integer(1)
         if verbose:
             print '%-6s%-10.2f%2s  %-3.2f%10.2f%10.2f'%(k, price_series[k],
                   signal, investment, price_series[k]/start_price, percent_change)
         buyhold.append(price_series[k]/start_price)
         strategy.append(investment)
         if signal == Integer(1):  # buy
             investment = investment * (percent_change + Integer(1))
         else: # short
             investment = investment * (Integer(1)/(percent_change + Integer(1)))
    # end for
    show(plot(TimeSeries(buyhold)) +
          plot(TimeSeries(strategy),linestyle='--',thickness=Integer(2), rgbcolor='red'),
         frame=True)
    return strategy[-Integer(1)], buyhold[-Integer(1)],


# You can add your own symbols (they must be on nasdeq or nyse):
print "loading stock data from web..."
symbols = ['ibm', 'vmw', 'sbux', 'aapl', 'amzn', 'goog',
       'wfmi', 'msft', 'yhoo', 'ebay', 'java', 'rht', ]
stocks = dict([(s, finance.Stock(s).close()) for s in symbols])
symbols.append('dji')
symbols.sort()
stocks['dji'] = load('http://sage.math.washington.edu/home/simuw/simuw08/data/sobj/DJI.sobj', verbose=False)
print "got stock data."

@interact
def f(start_days_ago=Integer(200), end_days_ago=Integer(0), days_in_moving_average=(Integer(10),(ellipsis_iter(Integer(1),Ellipsis,Integer(100)))), table=False,
       symbol=selector(symbols,buttons=True,default='dji'), contrarian=True):
    start = start_days_ago; end = end_days_ago
    price_series = stocks[symbol]
    n = len(price_series)
    if start < end: print "start must be greater than end"; return
    print "** %s **"%symbol.upper()
    print "Starting %s days ago and going until %s days ago"%(start, end)
    print "Solid blue line is buy and hold."
    print "Dashed red line is simple moving average strategy."
    strat, buy_hold = strategy(price_series, n-start, n-end,
              days_in_moving_average, table, contrarian)
    print "STRATEGY: %s   BUY&HOLD: %s"%(strat, buy_hold)

print "e94"
